
/* ===================
     <<nanba160.c>>

     for UNIX(gcc)  modified by T.AIBA 1996/02/15
   =================== */

#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <string.h>

#include "jstring.c"
#include <time.h>

#define WORDS_MAX 2500
#define KUTOTEN_LEN 41
#define KUGIRI " !?:;.,^~_/<>()[]{}\'\"\t\n\
ġšʡˡΡϡ֡ס̡͡Сѡҡӡԡաء١ڡۡȡɡơ"

void title_a();
void title_b();
void usage();
void stop(char *p);
void prt(char *p,char _dtype);
void cprt(char *p,char _dtype);
double rand1();
int rand100();
int set_val(int a,int l,int h);
char *strtail(char *p,int n);
char *get_strval(char *p);
char *jstrrem(char *s,char *t);
void open_infile();
void open_outfile();
void read_data();
int get_opt1(int n,char **p);
void get_opt2();
void sel(int wtype);
void inflect();


/*    */
int mn=1;		/*  ʸĹ(Ǿ)  */
int mx=5;		/*  ʸĹ()  */
int sn=6;		/*  ʸθĿ(1-32000)  */
int rc=2;		/*  Ʊνʣåɤ٤뤫(0-10)  */
int sc=60;		/*  ά(0-100)  */
int sh=70;		/*  ά(0-100)  */
int jt=50;		/*  ҸΤ¾ưγ(0-100)  */
int sz=50;		/*  ³ʸʸ³(0-100)  */
int bm=50;		/*  ʸʸ򽪤餻(0-100)  */
char kuten[KUTOTEN_LEN]="";	/*    */
char toten[KUTOTEN_LEN]="";	/*    */
int c_outs=0;	/* Ϥ(0=̵,or 1-32000) */

char *w[WORDS_MAX],buf[256],tmp[256];
char sz_b[5]; /* ³νʣå */
char jt_b[3][5],bm_b[5]; /* ʸνҸνʣå */
char infile[81]="",outfile[81]="";
unsigned char count[WORDS_MAX];
int wlow[8],whigh[8],wnum[8],wcheck[8],wmax;

char dtype; /* ʸ(0=console,1=disk,2=console&disk) */
char nf=0; /* ɽ */
char chkfo=0; /* ե */
char chkinf=0,chkoutf=0; /* ץ */

FILE *fp;



main(int argc,char **argv)
{
	int a,slen,st;
	int chp=0; /* ʬ */

	srand((unsigned)time(NULL));
	/*
	printf("\33[2J");
	*/
	dtype=0;
	/*
	title_a();
	*/

	if(argc>1){get_opt1(argc,argv);}

	open_infile();
	read_data();
	if(chkfo==0){
		open_outfile();
		dtype=1;
		/*
		title_b();
		prt("ե̾:",dtype); prt(infile,dtype); prt("\n\n",dtype);
		*/
	}

	if(nf==0 && chkfo==0) dtype=2;

mainloop:

	slen=abs(mn+rand1()*(mx-mn+1));  /* ʸĹ */
	if(slen<1)slen=1;
	st=1;  /* 'ʸƬ'򼨤 */

	for(a=1;a<=slen;a++){

	/*  礽Σ  */
		if(rand100()>sh){
			sel(2);
			cprt(tmp,dtype);
		}

	/*  Ƚ  */
		if(rand100()>sc || st==1){
			st=0;
			sel(0);
			cprt(tmp,dtype);
			sel(1);
			cprt(tmp,dtype);
		}

	/*  礽Σ  */
		if(rand100()>sh){
			sel(2);
			cprt(tmp,dtype);
		}
	
	/*  Ҹ  */
		if(rand100()<jt) sel(3); /* ư */
		else{
			sel(0); /* Ū */
			cprt(tmp,dtype);
			sel(4); /* ¾ư */
		}
	
	/*  ʸ³ޤʸ  */
		if(a<slen){
			if(rand100()<sz){
				cprt(tmp,dtype);
				sel(5);  /* ³ */
				cprt(tmp,dtype);
			}
			else{
				inflect(); /* Ѳ */
				cprt(tmp,dtype);
			}
		}
		else {
			cprt(tmp,dtype);
			if(rand100()<bm){
				sel(6); /* ʸ */
				cprt(tmp,dtype);
			}
			cprt(kuten,dtype); /*  */
		}
	
	}

	/*  ʬ  */
	chp++;
	if(chp==sn){
		prt("\n\n",dtype);
		chp=0;
		if(nf==1) printf(".");

		if(c_outs!=0){
			c_outs--;
			if(c_outs<=0){goto end_of_main;}
		}
	}

	if(rc!=0){
		for(a=0;a<=wmax;a++){
			if(count[a]>0) count[a]--;
		}
	}

	/*
	if(kbhit()==0)
	*/
	  goto mainloop;

	/*
	getch();
	*/
	end_of_main:
		prt("\n\n",dtype);
	        /*
		fcloseall();
		*/
		exit(0);
}


void title_a(){
	int a;
	for(a=1;a<=23;a++) prt("",dtype);
	prt("\n",dtype);
	prt("ưʸեȡХܥVer.1.60    \n",dtype);
	for(a=1;a<=23;a++) prt("",dtype);
	prt("\n",dtype);
}

void title_b(){
	int a;
	time_t tm;
	time(&tm);
	for(a=1;a<=37;a++) prt("",dtype);
	prt("\n",dtype);
	prt("ưʸեȡХܥVer.1.60    ",dtype);
	prt(ctime(&tm),dtype);
	for(a=1;a<=37;a++) prt("",dtype);
	prt("\n",dtype);
}


void usage(){
	printf("command option:\n"
		" -i[filename]  եλ     -n  ɽ\n"
		" -o[filename]  ϥեλ     -v  եϤʤ\n"
		" -s[1-32000]   Ϥ\n\n");
	printf("data option:\n"
		" -MN[1-100]    ʸĹ(Ǿ)       -JT[0-100]   ¾ưγ\n"
		" -MX[1-100]    ʸĹ()       -SZ[0-100]   ³γ\n"
		" -SN[1-32000]  ʸθĿ       -BM[0-100]   ʸγ\n"
		" -RC[0-10]     νʣå     -KT\"ʸ\"  \n"
		" -SC[0-100]    ά     -TT\"ʸ\"  \n"
		" -SH[0-100]    ά\n");
}


void stop(char *p){
	printf("%s\a\n",p);
	/*
	fcloseall();
	*/
	exit(1);
}


void prt(char *p,char _dtype){
	switch(_dtype){
	case 3:
		break;
	case 2:
		printf("%s",p);
	case 1:
		if(EOF == fputs(p,fp)){
			stop("\nError:եϤޤޤf");
		}
		break;
	case 0:
		printf("%s",p);
		break;
	}
}


void cprt(char *p,char _dtype){
	switch(_dtype){
	case 3:
		break;
	case 2:
		printf("%s",p);
	case 1:
		if(EOF == fputs(p,fp)){
			stop("\nError:եϤޤޤc");
		}
		break;
	case 0:
		printf("%s",p);
		break;
	}
}


double rand1(){
	return( (double)(rand()%0x10000)/0x10000 );
}


int rand100(){
	return((rand()%0x10000)%100);
}


int set_val(int a,int l,int h){
	if(a<l){return(l);}
	if(a>h){return(h);}
	return(a);
}


char *strtail(char *p,int n){
	static char tmp[256];
	int a;

	if(strlen(p)>255)return(NULL);

	if(n>strlen(p)) n=strlen(p);
	for(a=0;a<=n-1;a++){
		tmp[a]=*(p+strlen(p)-n+a);
	}
	tmp[n]='\0';

	return(tmp);
}


char *get_strval(char *p){
	static char tmp[41];
	int a=0,b=0;

	if(strlen(p)>40) return(NULL);

	for(a=0;a<=strlen(p);a++){
		if(a>=strlen(p)) return(NULL);
		if(*(p+a)=='\"') break;
	}
	a++;

	for(;a<=strlen(p);a++){
		tmp[b]=*(p+a);
		if(a>=strlen(p)) return(NULL);
		if(*(p+a)=='\"') break;
		b++;
	}

	tmp[b]='\0';
	return(tmp);
}


char *jstrrem(char *s,char *t){
	char *p;
	static char v[256]="";
	if(strlen(s)>255){return(NULL);}
	strcpy(v,p=jstrtok(s,t));
	while((p=jstrtok(NULL,t))!=NULL){
		strcat(v,p);
	}
	return(v);
}


void open_infile(){
	if(chkinf==0){
		printf("dict filename: ");
		gets(infile);
	}
	if(infile[0]=='\0')  strcpy(infile,"nanba.nb1");
	else if(strchr(infile,'.')==NULL)  strcat(infile,".nb1");
	if((fp=fopen(infile,"r"))==NULL){
		stop("\nError:Cannot Open Dict File.");
	}
	printf("\n");
}


void open_outfile(){
	if(chkoutf==0){
		printf("output filename: ");
		gets(outfile);
	}
	if(outfile[0]=='\0') strcpy(outfile,"nanba.txt");
	if((fp=fopen(outfile,"w"))==NULL){
		stop("\nError:Cannot Create Output File.");
	}
}


void read_data(){
	int a=0;

	wlow[0]=0;
	wmax=0;

	loop:
	fgets(buf,240,fp);
	if(strlen(buf)>200){buf[200]='\0';}

	switch(buf[0]){
	case'\n':
	case'\'':
		 goto loop;
	case'-':
	case'/':
		get_opt2();
		goto loop;
	case'@':
		whigh[a]=wmax-1;
		a++;
		if(a<=6){
			wlow[a]=wmax;
			goto loop;
		}
		else break;
	case'\0':
		stop("Error:եιܿ­ʤߤǤ");
		exit(1);
	default:
		if((w[wmax]=(char *)malloc(strlen(buf)+1))==NULL){
			stop("Error:꤬­ʤ, ǡ礭褦Ǥ");
		}
		buf[strlen(buf)-1]='\0';
		strcpy(w[wmax],buf);
		wmax++;
		if(wmax>=WORDS_MAX){
			stop("Error:ǡθĿ¿ޤ");
		}
		goto loop;
	}
	fclose(fp);
	/*
	printf("%dĤθɤ߹ߤޤ\n\n",wmax);
	*/

	for(a=0;a<=6;a++){
		wnum[a]=whigh[a]-wlow[a]+1;
		wcheck[a]=wnum[a]*rc/10;
		if(wcheck[a]>255)wcheck[a]=255;
	}
}


int get_opt1(int n,char **p){
	int a;
	char t[81];

	for(a=1;a<=n-1;a++){
		strncpy(t,*(p+a),80);
		t[80]='\0';
		if(t[0]=='-' || t[0]=='/'){

			switch(t[1]){
			/*--------------------------------------*/
			case'n':	/* ɽ */
			case'N':
				if(strlen(t)>2)goto mukou;
				if(chkfo!=0)goto mukou;
				nf=1;
				break;

			/*--------------------------------------*/
			case'v':
			case'V':	/* եϤ򤷤ʤ */
				if(strlen(t)>2)goto mukou;
				if(nf==1)goto mukou;
				if(strlen(outfile)!=0)goto mukou;
				chkfo=1;
				break;

			/*--------------------------------------*/
			case'i':	/* ϥե̾λ */
			case'I':
				if(strlen(infile)>0)goto mukou;
				if(strlen(t)>2){
					strcpy(infile,strtail(t,strlen(t)-2));
					chkinf=1;
					break;
				}
				else if(a<n-1){
					char _tmp[2];
					strncpy(_tmp,*(p+a+1),1);
					if(_tmp[0]!='-'){
						strncpy(infile,*(p+a+1),80);
						chkinf=1;
						a++;
						break;
					}
					else goto mukou;
				}
				else goto mukou;
				break;

			/*--------------------------------------*/
			case'o':	/* ϥե̾λ */
			case'O':
				if(strlen(outfile)>0)goto mukou;
				if(chkfo!=0)goto mukou;
				if(strlen(t)>2){
					strcpy(outfile,strtail(t,strlen(t)-2));
					chkoutf=1;
					break;
				}
				else if(a<n-1){
					char _tmp[2];
					strncpy(_tmp,*(p+a+1),1);
					if(_tmp[0]!='-'){
						strncpy(outfile,*(p+a+1),80);
						chkoutf=1;
						a++;
						break;
					}
					else goto mukou;
				}
				else goto mukou;
				break;

			/*--------------------------------------*/
			case's':	/* Ϥ */
			case'S':
				if(c_outs!=0)goto mukou;
				if(strlen(t)>2){
					char _tmp[80];
					strcpy(_tmp,strtail(t,strlen(t)-2));
					c_outs=set_val(atoi(_tmp),1,32000);
					break;
				}
				else if(a<n-1){
					char _tmp[80];
					strncpy(_tmp,*(p+a+1),1);
					if(_tmp[0]!='-' && _tmp[0]!='/'){
						strncpy(_tmp,*(p+a+1),80);
						c_outs=set_val(atoi(_tmp),1,32000);
						a++;
						break;
					}
					else goto mukou;
				}
				else goto mukou;
				break;

			/*--------------------------------------*/
			case'h':	/* إɽ */
			case'H':
			case'?':
				usage();
				exit(0);

			/*--------------------------------------*/
			default:
				goto mukou;
			}/*switch*/

		}/*if*/
		else{
			mukou:
			printf("Warning:ץ̵Ǥ\n");
			printf("%s\n\n",t);
		}

	}
}


void get_opt2(){
	int c;
	char _tmp[3];

	if(strlen(buf)<3){goto mukou;}

	_tmp[0]=tolower(buf[1]),_tmp[1]=tolower(buf[2]),_tmp[2]='\0';
	c=atoi(&buf[3]);

	if(strcmp(_tmp,"mn")==0 && c>=0){mn=set_val(c,1,100);return;}
	else if(strcmp(_tmp,"mx")==0 && c>=0){mx=set_val(c,1,100);return;}
	else if(strcmp(_tmp,"sn")==0 && c>=0){sn=set_val(c,1,32000);return;}
	else if(strcmp(_tmp,"rc")==0 && c>=0){rc=set_val(c,0,10);return;}
	else if(strcmp(_tmp,"bm")==0 && c>=0){bm=set_val(c,0,100);return;}
	else if(strcmp(_tmp,"sc")==0 && c>=0){sc=set_val(c,0,100);return;}
	else if(strcmp(_tmp,"sh")==0 && c>=0){sh=set_val(c,0,100);return;}
	else if(strcmp(_tmp,"sz")==0 && c>=0){sz=set_val(c,0,100);return;}
	else if(strcmp(_tmp,"jt")==0 && c>=0){jt=set_val(c,0,100);return;}
	else if(strcmp(_tmp,"kt")==0){
		char *s;
		s=get_strval(buf);
		if(s!=NULL){strcpy(kuten,s);return;}
	}
	else if(strcmp(_tmp,"tt")==0){
		char *s;
		s=get_strval(buf);
		if(s!=NULL){strcpy(toten,s);return;}
	}

	mukou:
		printf("Warning:ץ̵Ǥ(%s)\n",infile);
		printf("%s\n",buf);
}


void sel(int wtype){
	int a;
	char sz_count=15,jt_count=15,fm_count=15;

	strcpy(buf,tmp);

	loop:
	a=wlow[wtype]+wnum[wtype]*rand1();
	if(count[a]>0) {
		count[a]--;
		goto loop;
	}

	/*--------------------------------------*/
	/* 㳰 */
	if(strlen(w[a])>=4 && strcmp(strtail(buf,2),"")==0){
		char _left[5];
		strncpy(_left,w[a],4);
		_left[4]='\0';

		/* (ƻ+⊥Բ) */
		if(strcmp(_left,"٤")==0) goto loop;
		if(strcmp(_left,"٤")==0) goto loop;
		if(strcmp(_left,"٤")==0) goto loop;
		if(strcmp(_left,"٤")==0) goto loop;

		/* (ƻ+Բ) */
		if(strcmp(_left,"")==0) goto loop;

		/* (ƻ+ޥԲ) */
		if(strcmp(_left,"")==0) goto loop;

		/* (ƻ+⺥Բ) */
		if(strcmp(_left,"ˤ")==0) goto loop;

		/* (ƻ+⪥Բ) */
		if(strcmp(_left,"ޤ")==0) goto loop;

	}

	/*--------------------------------------*/
	/* ³νʣå */
	if(sz_count>0 && wtype==5){
		char _tmp[256];
		strcpy(_tmp,w[a]);
		strcpy(_tmp,jstrrem(_tmp,toten));
		strcpy(_tmp,jstrrem(_tmp,KUGIRI));
		strcpy(_tmp,strtail(_tmp,4));
		if(strcmp(_tmp,sz_b)==0){
			sz_count--;
			goto loop;
		}
		strcpy(sz_b,_tmp);
	}

	/*--------------------------------------*/
	/* ʸνҸνʣå */
	if(jt_count>0 && wtype==6){
		int c;
		char _tmp[5];
		strcpy(_tmp,strtail(w[a],4));
		if(strcmp(_tmp,bm_b)==0){
			jt_count--;
			goto loop;
		}
		for(c=0;c<=2;c++){
			if(strcmp(_tmp,jt_b[c])==0){
				jt_count--;
				goto loop;
			}
		}
		strcpy(bm_b,_tmp);
	}

	if(wtype==3 || wtype==4){
		int c;
		for(c=0;c<=1;c++){strcpy(jt_b[c],jt_b[c+1]);}
		strcpy(jt_b[2],strtail(w[a],4));
	}

	/*--------------------------------------*/
	/* ľθȤӤˤʣå */
	if(fm_count>0){
		if(jstrstr(buf,"Ǥ")!=NULL && jstrstr(w[a],"Ǥ")!=NULL){
			fm_count--; goto loop;}

		if(jstrstr(buf,"")!=NULL && jstrstr(w[a],"")!=NULL){
			fm_count--; goto loop;}

		if(jstrstr(buf,"Ȥ")!=NULL && jstrstr(w[a],"Ȥ")!=NULL){
			fm_count--; goto loop;}

		if(jstrstr(buf,"ȸ")!=NULL && jstrstr(w[a],"ȸ")!=NULL){
			fm_count--; goto loop;}

		if(jstrstr(buf,"Ǥ")!=NULL && jstrstr(w[a],"Ǥ")!=NULL){
			fm_count--; goto loop;}

		if(jstrstr(buf,"")!=NULL && jstrstr(w[a],"")!=NULL){
			fm_count--; goto loop;}
	}

	/*--------------------------------------*/

	strcpy(tmp,w[a]);
	count[a]=wcheck[wtype];

}


void inflect(){
	int f=0;
	char _left[256],_right[21];

	if(strlen(tmp)>6){
		strcpy(_left,tmp);
		_left[strlen(tmp)-6]='\0';
		strcpy(_right,strtail(tmp,6));

		if(strcmp(_right,"ʤ")==0) strcat(_left,""),f=1;
		else if(strcmp(_right,"Ϥʤ")==0) strcat(_left,"Ϥʤ"),f=1;
		else if(strcmp(_right,"ʤ")==0) strcat(_left,"ʤ"),f=1;
		else if(strcmp(_right,"ˤʤ")==0) strcat(_left,"ˤʤ"),f=1;
		else if(strcmp(_right,"Ƥ")==0) strcat(_left,"Ƥ"),f=1;
		else if(strcmp(_right,"Ǥ")==0) strcat(_left,"Ǥ"),f=1;
	}

	if(f==0 && strlen(tmp)>4){
		strcpy(_left,tmp);
		_left[strlen(tmp)-4]='\0';
		strcpy(_right,strtail(tmp,4));

		if(strcmp(_right,"")==0) strcat(_left,""),f=1;
		else if(strcmp(_right,"")==0) strcat(_left,""),f=1;
		else if(strcmp(_right,"")==0) strcat(_left,""),f=1;
		else if(strcmp(_right,"")==0) strcat(_left,""),f=1;
		else if(strcmp(_right,"")==0) strcat(_left,""),f=1;
		else if(strcmp(_right,"")==0) strcat(_left,""),f=1;
		else if(strcmp(_right,"")==0) strcat(_left,""),f=1;
		else if(strcmp(_right,"")==0) strcat(_left,""),f=1;
		else if(strcmp(_right,"")==0) strcat(_left,""),f=1;
		else if(strcmp(_right,"")==0) strcat(_left,""),f=1;
		else if(strcmp(_right,"")==0) strcat(_left,""),f=1;
		else if(strcmp(_right,"")==0) strcat(_left,""),f=1;
		else if(strcmp(_right,"Ф")==0) strcat(_left,"Ф"),f=1;
		else if(strcmp(_right,"")==0) strcat(_left,""),f=1;
		else if(strcmp(_right,"")==0) strcat(_left,""),f=1;
		else if(strcmp(_right,"")==0) strcat(_left,""),f=1;
		else if(strcmp(_right,"礦")==0) strcat(_left,"礤"),f=1;
	}

	if(f==0 && strlen(tmp)>2){
		strcpy(_left,tmp);
		_left[strlen(tmp)-2]='\0';
		strcpy(_right,strtail(tmp,2));

		if(strcmp(_right,"")==0) strcat(_left,""),f=1;
		else if(strcmp(_right,"")==0) strcat(_left,""),f=1;
		else if(strcmp(_right,"")==0) strcat(_left,""),f=1;
		else if(strcmp(_right,"")==0) strcat(_left,""),f=1;
		else if(strcmp(_right,"")==0) strcat(_left,""),f=1;
		else if(strcmp(_right,"")==0) strcat(_left,""),f=1;
	}
	
	if(f==1) strcpy(tmp,_left);
	else strcat(tmp,"");

	strcat(tmp,toten);
}


/* ɤߤˤեǿޤ(^^;)ʤߤˤΥեȤ
   ԤϤǤˣøλȤۤȤ˺ƤޤäΤǡŪ
   ̤ˤĤƤΤո˾ˤϤǤޤ(^^;)               */

